// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddConfigsourceAuditVersionReader is a Reader for the AddConfigsourceAuditVersion structure.
type AddConfigsourceAuditVersionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddConfigsourceAuditVersionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddConfigsourceAuditVersionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddConfigsourceAuditVersionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddConfigsourceAuditVersionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddConfigsourceAuditVersionOK creates a AddConfigsourceAuditVersionOK with default headers values
func NewAddConfigsourceAuditVersionOK() *AddConfigsourceAuditVersionOK {
	return &AddConfigsourceAuditVersionOK{}
}

/* AddConfigsourceAuditVersionOK describes a response with status code 200, with default header values.

successful operation
*/
type AddConfigsourceAuditVersionOK struct {
	Payload *models.ConfigSource
}

func (o *AddConfigsourceAuditVersionOK) Error() string {
	return fmt.Sprintf("[POST /setting/configsources/{id}/audit][%d] addConfigsourceAuditVersionOK  %+v", 200, o.Payload)
}
func (o *AddConfigsourceAuditVersionOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *AddConfigsourceAuditVersionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddConfigsourceAuditVersionTooManyRequests creates a AddConfigsourceAuditVersionTooManyRequests with default headers values
func NewAddConfigsourceAuditVersionTooManyRequests() *AddConfigsourceAuditVersionTooManyRequests {
	return &AddConfigsourceAuditVersionTooManyRequests{}
}

/* AddConfigsourceAuditVersionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddConfigsourceAuditVersionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddConfigsourceAuditVersionTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/configsources/{id}/audit][%d] addConfigsourceAuditVersionTooManyRequests ", 429)
}

func (o *AddConfigsourceAuditVersionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddConfigsourceAuditVersionDefault creates a AddConfigsourceAuditVersionDefault with default headers values
func NewAddConfigsourceAuditVersionDefault(code int) *AddConfigsourceAuditVersionDefault {
	return &AddConfigsourceAuditVersionDefault{
		_statusCode: code,
	}
}

/* AddConfigsourceAuditVersionDefault describes a response with status code -1, with default header values.

Error
*/
type AddConfigsourceAuditVersionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add configsource audit version default response
func (o *AddConfigsourceAuditVersionDefault) Code() int {
	return o._statusCode
}

func (o *AddConfigsourceAuditVersionDefault) Error() string {
	return fmt.Sprintf("[POST /setting/configsources/{id}/audit][%d] addConfigsourceAuditVersion default  %+v", o._statusCode, o.Payload)
}
func (o *AddConfigsourceAuditVersionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddConfigsourceAuditVersionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
