// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddDatasourceAuditVersionReader is a Reader for the AddDatasourceAuditVersion structure.
type AddDatasourceAuditVersionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDatasourceAuditVersionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDatasourceAuditVersionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDatasourceAuditVersionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDatasourceAuditVersionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDatasourceAuditVersionOK creates a AddDatasourceAuditVersionOK with default headers values
func NewAddDatasourceAuditVersionOK() *AddDatasourceAuditVersionOK {
	return &AddDatasourceAuditVersionOK{}
}

/* AddDatasourceAuditVersionOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDatasourceAuditVersionOK struct {
	Payload *models.DataSource
}

func (o *AddDatasourceAuditVersionOK) Error() string {
	return fmt.Sprintf("[POST /setting/datasources/{id}/audit][%d] addDatasourceAuditVersionOK  %+v", 200, o.Payload)
}
func (o *AddDatasourceAuditVersionOK) GetPayload() *models.DataSource {
	return o.Payload
}

func (o *AddDatasourceAuditVersionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DataSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDatasourceAuditVersionTooManyRequests creates a AddDatasourceAuditVersionTooManyRequests with default headers values
func NewAddDatasourceAuditVersionTooManyRequests() *AddDatasourceAuditVersionTooManyRequests {
	return &AddDatasourceAuditVersionTooManyRequests{}
}

/* AddDatasourceAuditVersionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDatasourceAuditVersionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddDatasourceAuditVersionTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/datasources/{id}/audit][%d] addDatasourceAuditVersionTooManyRequests ", 429)
}

func (o *AddDatasourceAuditVersionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDatasourceAuditVersionDefault creates a AddDatasourceAuditVersionDefault with default headers values
func NewAddDatasourceAuditVersionDefault(code int) *AddDatasourceAuditVersionDefault {
	return &AddDatasourceAuditVersionDefault{
		_statusCode: code,
	}
}

/* AddDatasourceAuditVersionDefault describes a response with status code -1, with default header values.

Error
*/
type AddDatasourceAuditVersionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add datasource audit version default response
func (o *AddDatasourceAuditVersionDefault) Code() int {
	return o._statusCode
}

func (o *AddDatasourceAuditVersionDefault) Error() string {
	return fmt.Sprintf("[POST /setting/datasources/{id}/audit][%d] addDatasourceAuditVersion default  %+v", o._statusCode, o.Payload)
}
func (o *AddDatasourceAuditVersionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDatasourceAuditVersionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
