// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewAddEventsourceAuditVersionParams creates a new AddEventsourceAuditVersionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddEventsourceAuditVersionParams() *AddEventsourceAuditVersionParams {
	return &AddEventsourceAuditVersionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddEventsourceAuditVersionParamsWithTimeout creates a new AddEventsourceAuditVersionParams object
// with the ability to set a timeout on a request.
func NewAddEventsourceAuditVersionParamsWithTimeout(timeout time.Duration) *AddEventsourceAuditVersionParams {
	return &AddEventsourceAuditVersionParams{
		timeout: timeout,
	}
}

// NewAddEventsourceAuditVersionParamsWithContext creates a new AddEventsourceAuditVersionParams object
// with the ability to set a context for a request.
func NewAddEventsourceAuditVersionParamsWithContext(ctx context.Context) *AddEventsourceAuditVersionParams {
	return &AddEventsourceAuditVersionParams{
		Context: ctx,
	}
}

// NewAddEventsourceAuditVersionParamsWithHTTPClient creates a new AddEventsourceAuditVersionParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddEventsourceAuditVersionParamsWithHTTPClient(client *http.Client) *AddEventsourceAuditVersionParams {
	return &AddEventsourceAuditVersionParams{
		HTTPClient: client,
	}
}

/* AddEventsourceAuditVersionParams contains all the parameters to send to the API endpoint
   for the add eventsource audit version operation.

   Typically these are written to a http.Request.
*/
type AddEventsourceAuditVersionParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.Audit

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add eventsource audit version params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddEventsourceAuditVersionParams) WithDefaults() *AddEventsourceAuditVersionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add eventsource audit version params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddEventsourceAuditVersionParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddEventsourceAuditVersionParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithTimeout(timeout time.Duration) *AddEventsourceAuditVersionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithContext(ctx context.Context) *AddEventsourceAuditVersionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithHTTPClient(client *http.Client) *AddEventsourceAuditVersionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithUserAgent(userAgent *string) *AddEventsourceAuditVersionParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithBody(body *models.Audit) *AddEventsourceAuditVersionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetBody(body *models.Audit) {
	o.Body = body
}

// WithID adds the id to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) WithID(id int32) *AddEventsourceAuditVersionParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the add eventsource audit version params
func (o *AddEventsourceAuditVersionParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AddEventsourceAuditVersionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
