// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetCollectorByHostNameReader is a Reader for the GetCollectorByHostName structure.
type GetCollectorByHostNameReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorByHostNameReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorByHostNameOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorByHostNameTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorByHostNameDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorByHostNameOK creates a GetCollectorByHostNameOK with default headers values
func NewGetCollectorByHostNameOK() *GetCollectorByHostNameOK {
	return &GetCollectorByHostNameOK{}
}

/* GetCollectorByHostNameOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorByHostNameOK struct {
	Payload *models.Response
}

func (o *GetCollectorByHostNameOK) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/getCollectorByHostName][%d] getCollectorByHostNameOK  %+v", 200, o.Payload)
}
func (o *GetCollectorByHostNameOK) GetPayload() *models.Response {
	return o.Payload
}

func (o *GetCollectorByHostNameOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorByHostNameTooManyRequests creates a GetCollectorByHostNameTooManyRequests with default headers values
func NewGetCollectorByHostNameTooManyRequests() *GetCollectorByHostNameTooManyRequests {
	return &GetCollectorByHostNameTooManyRequests{}
}

/* GetCollectorByHostNameTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorByHostNameTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetCollectorByHostNameTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/getCollectorByHostName][%d] getCollectorByHostNameTooManyRequests ", 429)
}

func (o *GetCollectorByHostNameTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorByHostNameDefault creates a GetCollectorByHostNameDefault with default headers values
func NewGetCollectorByHostNameDefault(code int) *GetCollectorByHostNameDefault {
	return &GetCollectorByHostNameDefault{
		_statusCode: code,
	}
}

/* GetCollectorByHostNameDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorByHostNameDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get collector by host name default response
func (o *GetCollectorByHostNameDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorByHostNameDefault) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/getCollectorByHostName][%d] getCollectorByHostName default  %+v", o._statusCode, o.Payload)
}
func (o *GetCollectorByHostNameDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorByHostNameDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
