// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewValidateCollectorConfigParams creates a new ValidateCollectorConfigParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewValidateCollectorConfigParams() *ValidateCollectorConfigParams {
	return &ValidateCollectorConfigParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewValidateCollectorConfigParamsWithTimeout creates a new ValidateCollectorConfigParams object
// with the ability to set a timeout on a request.
func NewValidateCollectorConfigParamsWithTimeout(timeout time.Duration) *ValidateCollectorConfigParams {
	return &ValidateCollectorConfigParams{
		timeout: timeout,
	}
}

// NewValidateCollectorConfigParamsWithContext creates a new ValidateCollectorConfigParams object
// with the ability to set a context for a request.
func NewValidateCollectorConfigParamsWithContext(ctx context.Context) *ValidateCollectorConfigParams {
	return &ValidateCollectorConfigParams{
		Context: ctx,
	}
}

// NewValidateCollectorConfigParamsWithHTTPClient creates a new ValidateCollectorConfigParams object
// with the ability to set a custom HTTPClient for a request.
func NewValidateCollectorConfigParamsWithHTTPClient(client *http.Client) *ValidateCollectorConfigParams {
	return &ValidateCollectorConfigParams{
		HTTPClient: client,
	}
}

/* ValidateCollectorConfigParams contains all the parameters to send to the API endpoint
   for the validate collector config operation.

   Typically these are written to a http.Request.
*/
type ValidateCollectorConfigParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.Collector

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the validate collector config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ValidateCollectorConfigParams) WithDefaults() *ValidateCollectorConfigParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the validate collector config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ValidateCollectorConfigParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := ValidateCollectorConfigParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the validate collector config params
func (o *ValidateCollectorConfigParams) WithTimeout(timeout time.Duration) *ValidateCollectorConfigParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the validate collector config params
func (o *ValidateCollectorConfigParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the validate collector config params
func (o *ValidateCollectorConfigParams) WithContext(ctx context.Context) *ValidateCollectorConfigParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the validate collector config params
func (o *ValidateCollectorConfigParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the validate collector config params
func (o *ValidateCollectorConfigParams) WithHTTPClient(client *http.Client) *ValidateCollectorConfigParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the validate collector config params
func (o *ValidateCollectorConfigParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the validate collector config params
func (o *ValidateCollectorConfigParams) WithUserAgent(userAgent *string) *ValidateCollectorConfigParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the validate collector config params
func (o *ValidateCollectorConfigParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the validate collector config params
func (o *ValidateCollectorConfigParams) WithBody(body *models.Collector) *ValidateCollectorConfigParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the validate collector config params
func (o *ValidateCollectorConfigParams) SetBody(body *models.Collector) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ValidateCollectorConfigParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
