// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// ValidateCollectorConfigReader is a Reader for the ValidateCollectorConfig structure.
type ValidateCollectorConfigReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ValidateCollectorConfigReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewValidateCollectorConfigOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewValidateCollectorConfigTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewValidateCollectorConfigDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewValidateCollectorConfigOK creates a ValidateCollectorConfigOK with default headers values
func NewValidateCollectorConfigOK() *ValidateCollectorConfigOK {
	return &ValidateCollectorConfigOK{}
}

/* ValidateCollectorConfigOK describes a response with status code 200, with default header values.

successful operation
*/
type ValidateCollectorConfigOK struct {
	Payload *models.Response
}

func (o *ValidateCollectorConfigOK) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors/lmotel/validateconfig][%d] validateCollectorConfigOK  %+v", 200, o.Payload)
}
func (o *ValidateCollectorConfigOK) GetPayload() *models.Response {
	return o.Payload
}

func (o *ValidateCollectorConfigOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewValidateCollectorConfigTooManyRequests creates a ValidateCollectorConfigTooManyRequests with default headers values
func NewValidateCollectorConfigTooManyRequests() *ValidateCollectorConfigTooManyRequests {
	return &ValidateCollectorConfigTooManyRequests{}
}

/* ValidateCollectorConfigTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ValidateCollectorConfigTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *ValidateCollectorConfigTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors/lmotel/validateconfig][%d] validateCollectorConfigTooManyRequests ", 429)
}

func (o *ValidateCollectorConfigTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewValidateCollectorConfigDefault creates a ValidateCollectorConfigDefault with default headers values
func NewValidateCollectorConfigDefault(code int) *ValidateCollectorConfigDefault {
	return &ValidateCollectorConfigDefault{
		_statusCode: code,
	}
}

/* ValidateCollectorConfigDefault describes a response with status code -1, with default header values.

Error
*/
type ValidateCollectorConfigDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the validate collector config default response
func (o *ValidateCollectorConfigDefault) Code() int {
	return o._statusCode
}

func (o *ValidateCollectorConfigDefault) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors/lmotel/validateconfig][%d] validateCollectorConfig default  %+v", o._statusCode, o.Payload)
}
func (o *ValidateCollectorConfigDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ValidateCollectorConfigDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
